module GI.WebKit2.Objects.Settings where

import Data.GI.Base.ShortPrelude

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Settings = Settings (ForeignPtr Settings)
instance GObject Settings where
class GObject o => SettingsK o
instance (GObject o, IsDescendantOf Settings o) => SettingsK o
data SettingsAllowFileAccessFromFileUrlsPropertyInfo
data SettingsAllowModalDialogsPropertyInfo
data SettingsAutoLoadImagesPropertyInfo
data SettingsCursiveFontFamilyPropertyInfo
data SettingsDefaultCharsetPropertyInfo
data SettingsDefaultFontFamilyPropertyInfo
data SettingsDefaultFontSizePropertyInfo
data SettingsDefaultMonospaceFontSizePropertyInfo
data SettingsDrawCompositingIndicatorsPropertyInfo
data SettingsEnableAccelerated2dCanvasPropertyInfo
data SettingsEnableCaretBrowsingPropertyInfo
data SettingsEnableDeveloperExtrasPropertyInfo
data SettingsEnableDnsPrefetchingPropertyInfo
data SettingsEnableFrameFlatteningPropertyInfo
data SettingsEnableFullscreenPropertyInfo
data SettingsEnableHtml5DatabasePropertyInfo
data SettingsEnableHtml5LocalStoragePropertyInfo
data SettingsEnableHyperlinkAuditingPropertyInfo
data SettingsEnableJavaPropertyInfo
data SettingsEnableJavascriptPropertyInfo
data SettingsEnableMediaStreamPropertyInfo
data SettingsEnableMediasourcePropertyInfo
data SettingsEnableOfflineWebApplicationCachePropertyInfo
data SettingsEnablePageCachePropertyInfo
data SettingsEnablePluginsPropertyInfo
data SettingsEnablePrivateBrowsingPropertyInfo
data SettingsEnableResizableTextAreasPropertyInfo
data SettingsEnableSiteSpecificQuirksPropertyInfo
data SettingsEnableSmoothScrollingPropertyInfo
data SettingsEnableSpatialNavigationPropertyInfo
data SettingsEnableTabsToLinksPropertyInfo
data SettingsEnableWebaudioPropertyInfo
data SettingsEnableWebglPropertyInfo
data SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo
data SettingsEnableXssAuditorPropertyInfo
data SettingsFantasyFontFamilyPropertyInfo
data SettingsJavascriptCanAccessClipboardPropertyInfo
data SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo
data SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo
data SettingsMediaPlaybackAllowsInlinePropertyInfo
data SettingsMediaPlaybackRequiresUserGesturePropertyInfo
data SettingsMinimumFontSizePropertyInfo
data SettingsMonospaceFontFamilyPropertyInfo
data SettingsPictographFontFamilyPropertyInfo
data SettingsPrintBackgroundsPropertyInfo
data SettingsSansSerifFontFamilyPropertyInfo
data SettingsSerifFontFamilyPropertyInfo
data SettingsUserAgentPropertyInfo
data SettingsZoomTextOnlyPropertyInfo
data SettingsGetAllowFileAccessFromFileUrlsMethodInfo
data SettingsGetAllowModalDialogsMethodInfo
data SettingsGetAutoLoadImagesMethodInfo
data SettingsGetCursiveFontFamilyMethodInfo
data SettingsGetDefaultCharsetMethodInfo
data SettingsGetDefaultFontFamilyMethodInfo
data SettingsGetDefaultFontSizeMethodInfo
data SettingsGetDefaultMonospaceFontSizeMethodInfo
data SettingsGetDrawCompositingIndicatorsMethodInfo
data SettingsGetEnableAccelerated2dCanvasMethodInfo
data SettingsGetEnableCaretBrowsingMethodInfo
data SettingsGetEnableDeveloperExtrasMethodInfo
data SettingsGetEnableDnsPrefetchingMethodInfo
data SettingsGetEnableFrameFlatteningMethodInfo
data SettingsGetEnableFullscreenMethodInfo
data SettingsGetEnableHtml5DatabaseMethodInfo
data SettingsGetEnableHtml5LocalStorageMethodInfo
data SettingsGetEnableHyperlinkAuditingMethodInfo
data SettingsGetEnableJavaMethodInfo
data SettingsGetEnableJavascriptMethodInfo
data SettingsGetEnableMediaStreamMethodInfo
data SettingsGetEnableMediasourceMethodInfo
data SettingsGetEnableOfflineWebApplicationCacheMethodInfo
data SettingsGetEnablePageCacheMethodInfo
data SettingsGetEnablePluginsMethodInfo
data SettingsGetEnablePrivateBrowsingMethodInfo
data SettingsGetEnableResizableTextAreasMethodInfo
data SettingsGetEnableSiteSpecificQuirksMethodInfo
data SettingsGetEnableSmoothScrollingMethodInfo
data SettingsGetEnableSpatialNavigationMethodInfo
data SettingsGetEnableTabsToLinksMethodInfo
data SettingsGetEnableWebaudioMethodInfo
data SettingsGetEnableWebglMethodInfo
data SettingsGetEnableWriteConsoleMessagesToStdoutMethodInfo
data SettingsGetEnableXssAuditorMethodInfo
data SettingsGetFantasyFontFamilyMethodInfo
data SettingsGetJavascriptCanAccessClipboardMethodInfo
data SettingsGetJavascriptCanOpenWindowsAutomaticallyMethodInfo
data SettingsGetLoadIconsIgnoringImageLoadSettingMethodInfo
data SettingsGetMediaPlaybackAllowsInlineMethodInfo
data SettingsGetMediaPlaybackRequiresUserGestureMethodInfo
data SettingsGetMinimumFontSizeMethodInfo
data SettingsGetMonospaceFontFamilyMethodInfo
data SettingsGetPictographFontFamilyMethodInfo
data SettingsGetPrintBackgroundsMethodInfo
data SettingsGetSansSerifFontFamilyMethodInfo
data SettingsGetSerifFontFamilyMethodInfo
data SettingsGetUserAgentMethodInfo
data SettingsGetZoomTextOnlyMethodInfo
data SettingsSetAllowFileAccessFromFileUrlsMethodInfo
data SettingsSetAllowModalDialogsMethodInfo
data SettingsSetAutoLoadImagesMethodInfo
data SettingsSetCursiveFontFamilyMethodInfo
data SettingsSetDefaultCharsetMethodInfo
data SettingsSetDefaultFontFamilyMethodInfo
data SettingsSetDefaultFontSizeMethodInfo
data SettingsSetDefaultMonospaceFontSizeMethodInfo
data SettingsSetDrawCompositingIndicatorsMethodInfo
data SettingsSetEnableAccelerated2dCanvasMethodInfo
data SettingsSetEnableCaretBrowsingMethodInfo
data SettingsSetEnableDeveloperExtrasMethodInfo
data SettingsSetEnableDnsPrefetchingMethodInfo
data SettingsSetEnableFrameFlatteningMethodInfo
data SettingsSetEnableFullscreenMethodInfo
data SettingsSetEnableHtml5DatabaseMethodInfo
data SettingsSetEnableHtml5LocalStorageMethodInfo
data SettingsSetEnableHyperlinkAuditingMethodInfo
data SettingsSetEnableJavaMethodInfo
data SettingsSetEnableJavascriptMethodInfo
data SettingsSetEnableMediaStreamMethodInfo
data SettingsSetEnableMediasourceMethodInfo
data SettingsSetEnableOfflineWebApplicationCacheMethodInfo
data SettingsSetEnablePageCacheMethodInfo
data SettingsSetEnablePluginsMethodInfo
data SettingsSetEnablePrivateBrowsingMethodInfo
data SettingsSetEnableResizableTextAreasMethodInfo
data SettingsSetEnableSiteSpecificQuirksMethodInfo
data SettingsSetEnableSmoothScrollingMethodInfo
data SettingsSetEnableSpatialNavigationMethodInfo
data SettingsSetEnableTabsToLinksMethodInfo
data SettingsSetEnableWebaudioMethodInfo
data SettingsSetEnableWebglMethodInfo
data SettingsSetEnableWriteConsoleMessagesToStdoutMethodInfo
data SettingsSetEnableXssAuditorMethodInfo
data SettingsSetFantasyFontFamilyMethodInfo
data SettingsSetJavascriptCanAccessClipboardMethodInfo
data SettingsSetJavascriptCanOpenWindowsAutomaticallyMethodInfo
data SettingsSetLoadIconsIgnoringImageLoadSettingMethodInfo
data SettingsSetMediaPlaybackAllowsInlineMethodInfo
data SettingsSetMediaPlaybackRequiresUserGestureMethodInfo
data SettingsSetMinimumFontSizeMethodInfo
data SettingsSetMonospaceFontFamilyMethodInfo
data SettingsSetPictographFontFamilyMethodInfo
data SettingsSetPrintBackgroundsMethodInfo
data SettingsSetSansSerifFontFamilyMethodInfo
data SettingsSetSerifFontFamilyMethodInfo
data SettingsSetUserAgentMethodInfo
data SettingsSetUserAgentWithApplicationDetailsMethodInfo
data SettingsSetZoomTextOnlyMethodInfo
